SoExtSelection Class Reference
Node Classes

The SoExtSelection class can be used for extended selection functionality. More...

`#include <Inventor/nodes/SoExtSelection.h>`

Inheritance diagram for SoExtSelection:

## Public Types

enum | LassoType { NOLASSO , LASSO , RECTANGLE }
enum | LassoPolicy { FULL_BBOX , PART_BBOX , FULL , PART }
enum | LassoMode { ALL_SHAPES , VISIBLE_SHAPES }
Public Types inherited from SoSelection
enum | Policy { SINGLE , TOGGLE , SHIFT , DISABLE }
Public Types inherited from SoSeparator
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoExtSelection (void)
void | useOverlay (SbBool overlay=TRUE)
SbBool | isUsingOverlay (void)
SoSeparator * | getOverlaySceneGraph (void)
void | setOverlayLassoColorIndex (const int index)
int | getOverlayLassoColorIndex (void)
void | setLassoColor (const SbColor &color)
const SbColor & | getLassoColor (void)
void | setLassoWidth (const float width)
float | getLassoWidth (void)
void | setOverlayLassoPattern (const unsigned short pattern)
unsigned short | getOverlayLassoPattern (void)
void | animateOverlayLasso (const SbBool animate=TRUE)
SbBool | isOverlayLassoAnimated (void)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
void | select (SoNode *root, int numcoords, SbVec2f *lasso, const SbViewportRegion &vp, SbBool shiftpolicy)
void | select (SoNode *root, int numcoords, SbVec3f *lasso, const SbViewportRegion &vp, SbBool shiftkeypolicy)
const SbVec2s * | getLassoCoordsDC (int &numCoords)
const SbVec3f * | getLassoCoordsWC (int &numCoords)
const SoPathList & | getSelectionPathList () const
void | setLassoFilterCallback (SoLassoSelectionFilterCB *f, void *userdata=NULL, const SbBool callonlyifselectable=TRUE)
void | setTriangleFilterCallback (SoExtSelectionTriangleCB *func, void *userdata=NULL)
void | setLineSegmentFilterCallback (SoExtSelectionLineSegmentCB *func, void *userdata=NULL)
void | setPointFilterCallback (SoExtSelectionPointCB *func, void *userdata=NULL)
SbBool | wasShiftDown (void) const
Public Member Functions inherited from SoSelection
| SoSelection (void)
| SoSelection (const int nChildren)
void | select (const SoPath *path)
void | select (SoNode *node)
void | deselect (const SoPath *path)
void | deselect (const int which)
void | deselect (SoNode *node)
void | toggle (const SoPath *path)
void | toggle (SoNode *node)
SbBool | isSelected (const SoPath *path) const
SbBool | isSelected (SoNode *node) const
void | deselectAll (void)
int | getNumSelected (void) const
const SoPathList * | getList (void) const
SoPath * | getPath (const int index) const
SoPath * | operator[] (const int i) const
void | addSelectionCallback (SoSelectionPathCB *f, void *userData=NULL)
void | removeSelectionCallback (SoSelectionPathCB *f, void *userData=NULL)
void | addDeselectionCallback (SoSelectionPathCB *f, void *userData=NULL)
void | removeDeselectionCallback (SoSelectionPathCB *f, void *userData=NULL)
void | addStartCallback (SoSelectionClassCB *f, void *userData=NULL)
void | removeStartCallback (SoSelectionClassCB *f, void *userData=NULL)
void | addFinishCallback (SoSelectionClassCB *f, void *userData=NULL)
void | removeFinishCallback (SoSelectionClassCB *f, void *userData=NULL)
void | setPickFilterCallback (SoSelectionPickCB *f, void *userData=NULL, const SbBool callOnlyIfSelectable=TRUE)
void | setPickMatching (const SbBool pickMatching)
SbBool | isPickMatching (void) const
SbBool | getPickMatching (void) const
void | addChangeCallback (SoSelectionClassCB *f, void *userData=NULL)
void | removeChangeCallback (SoSelectionClassCB *f, void *userData=NULL)
Public Member Functions inherited from SoSeparator
| SoSeparator (void)
| SoSeparator (const int nchildren)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | notify (SoNotList *nl)
virtual SbBool | affectsState (void) const
Public Member Functions inherited from SoGroup
| SoGroup (void)
| SoGroup (int nchildren)
virtual void | addChild (SoNode *node)
virtual void | insertChild (SoNode *child, int newchildindex)
virtual SoNode * | getChild (int index) const
virtual int | findChild (const SoNode *node) const
virtual int | getNumChildren (void) const
virtual void | removeChild (int childindex)
virtual void | removeChild (SoNode *child)
virtual void | removeAllChildren (void)
virtual void | replaceChild (int index, SoNode *newchild)
virtual void | replaceChild (SoNode *oldchild, SoNode *newchild)
virtual void | pick (SoPickAction *action)
virtual void | write (SoWriteAction *action)
virtual SoChildList * | getChildren (void) const
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoSelection
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoSeparator
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | setNumRenderCaches (const int howmany)
static int | getNumRenderCaches (void)
Static Public Member Functions inherited from SoGroup
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFEnum | lassoType
SoSFEnum | lassoPolicy
SoSFEnum | lassoMode
Public Attributes inherited from SoSelection
SoSFEnum | policy
Public Attributes inherited from SoSeparator
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoExtSelection ()
Protected Member Functions inherited from SoSelection
virtual | ~SoSelection ()
void | invokeSelectionPolicy (SoPath *path, SbBool shiftDown)
void | performSingleSelection (SoPath *path)
void | performToggleSelection (SoPath *path)
SoPath * | copyFromThis (const SoPath *path) const
void | addPath (SoPath *path)
void | removePath (const int which)
int | findPath (const SoPath *path) const
Protected Member Functions inherited from SoSeparator
virtual | ~SoSeparator ()
virtual SbBool | cullTest (SoState *state)
virtual SbBool | cullTest (SoGLRenderAction *action, int &cullresults)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoGroup
virtual | ~SoGroup ()
virtual SbBool | readChildren (SoInput *in)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoNotRec | createNotRec (void)
void | setOperation (const SoNotRec::OperationType opType=SoNotRec::UNSPECIFIED, const SoNode *cc=NULL, const SoNode *pc=NULL, const int ci=-1)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoSelection
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoSeparator
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoSelection
SoPathList | selectionList
SoCallbackList * | selCBList
SoCallbackList * | deselCBList
SoCallbackList * | startCBList
SoCallbackList * | finishCBList
SoSelectionPickCB * | pickCBFunc
void * | pickCBData
SbBool | callPickCBOnlyIfSelectable
SoCallbackList * | changeCBList
SoPath * | mouseDownPickPath
SbBool | pickMatching
Protected Attributes inherited from SoGroup
SoChildList * | children
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoExtSelection class can be used for extended selection functionality.

This class enables you to select geometry by specifying a lasso (a polygon) or a rectangle on screen. When objects are selected, you'll receive the same callbacks as for the SoSelection node.

The application programmer interface of this class is somewhat complex, due to its non-trivial functionality. To see an extensive usage example of the SoExtSelection node, we advise you to go look at the "extselection" example application in the "nodes/" directory of the SoGuiExamples Mercurial repository. Further information and links for downloading and building this module should be available at github.com/coin3d/soguiexamples.

This node class is an extension versus the original SGI Inventor v2.1 API. It is based on the API of VSG (was TGS) Inventor's SoExtSelection, and we aim to be fully compatible with this node to enable users to switch between using Coin and VSG Inventor. Please contact us if you find discrepancies between Coin's SoExtSelection and VSG's SoExtSelection node.

FILE FORMAT/DEFAULTS:

ExtSelection {
renderCaching AUTO
boundingBoxCaching AUTO
renderCulling AUTO
pickCulling AUTO
policy SHIFT
lassoType NOLASSO
lassoPolicy FULL_BBOX
lassoMode ALL_SHAPES
}
SoExtSelection::lassoPolicy
SoSFEnum lassoPolicy
Definition SoExtSelection.h:99
SoExtSelection::FULL_BBOX
@ FULL_BBOX
Definition SoExtSelection.h:90
SoExtSelection::lassoMode
SoSFEnum lassoMode
Definition SoExtSelection.h:100
SoExtSelection::ALL_SHAPES
@ ALL_SHAPES
Definition SoExtSelection.h:94
SoExtSelection::lassoType
SoSFEnum lassoType
Definition SoExtSelection.h:98
SoExtSelection::NOLASSO
@ NOLASSO
Definition SoExtSelection.h:86
SoSelection::policy
SoSFEnum policy
Definition SoSelection.h:63
SoSelection::SHIFT
@ SHIFT
Definition SoSelection.h:60
SoSeparator::boundingBoxCaching
SoSFEnum boundingBoxCaching
Definition SoSeparator.h:59
SoSeparator::AUTO
@ AUTO
Definition SoSeparator.h:55
SoSeparator::renderCaching
SoSFEnum renderCaching
Definition SoSeparator.h:58
SoSeparator::renderCulling
SoSFEnum renderCulling
Definition SoSeparator.h:60
SoSeparator::pickCulling
SoSFEnum pickCulling
Definition SoSeparator.h:61

Since
  TGS Inventor 2.5
  Coin 1.0

## Member Enumeration Documentation

## LassoType

enum SoExtSelection::LassoType

Enum for type of lasso selection.

Enumerator
NOLASSO | Makes this node behave like a normal SoSelection node.
LASSO | Select objects using a lasso. Selections can be aborted by the end-user by hitting the `END` key on the keyboard.
RECTANGLE | Select objects using a rectangle. Selections can be aborted by the end-user by hitting the `END` key on the keyboard.

## LassoPolicy

enum SoExtSelection::LassoPolicy

Enum for specifying how objects are selected.

Enumerator
FULL_BBOX | The entire bounding box must be inside the lasso/rectangle.
PART_BBOX | Some part of the bounding box must intersect the lasso/rectangle.
FULL | All primitives must be completely inside the lasso/rectangle.
PART | Some primitive must intersect the lasso/rectangle.

## LassoMode

enum SoExtSelection::LassoMode

Enum for specifying selection mode.

Enumerator
ALL_SHAPES | All primitives inside the lasso/rectangle will be selected.
VISIBLE_SHAPES | All visible primitives inside the lasso/rectangle will be selected.

## Constructor & Destructor Documentation

## SoExtSelection()

SoExtSelection::SoExtSelection | ( | void |  | ) |

Constructor.

## ~SoExtSelection()

SoExtSelection::~SoExtSelection | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoExtSelection::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoExtSelection::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoSelection.

## getFieldDataPtr()

const SoFieldData ** SoExtSelection::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoExtSelection::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoSelection.

## useOverlay()

void SoExtSelection::useOverlay | ( | SbBool | overlay = TRUE | ) |

Specifies whether the overlay planes should be used to render the lasso.

This method has been obsoleted in Coin, as most graphics cards comes without support for overlay rendering. A better strategy is to just "overlay" the lasso graphics on top of the scene after everything else has been rendered – and this is the strategy we apply in Coin.

## isUsingOverlay()

SbBool SoExtSelection::isUsingOverlay | ( | void |  | ) |

Returns whether overlay planes are used to draw the lasso.

See also
  useOverlay().

## getOverlaySceneGraph()

SoSeparator * SoExtSelection::getOverlaySceneGraph | ( | void |  | ) |

Returns the scene graph for overlay rendering. Will always return NULL in Coin, as this method has been obsoleted.

(It is probably used in TGS Inventor from the SoXt / SoWin libraries' So[Xt|Win]RenderArea class to fetch the overlay graph to draw, and as such should be treated as an internal method.)

## setOverlayLassoColorIndex()

void SoExtSelection::setOverlayLassoColorIndex | ( | const int | index | ) |

Obsoleted in Coin, use SoExtSelection::setLassoColor() instead.

## getOverlayLassoColorIndex()

int SoExtSelection::getOverlayLassoColorIndex | ( | void |  | ) |

Obsoleted in Coin, use SoExtSelection::getLassoColor() instead.

See also
  setOverlayLassoColorIndex().

## setLassoColor()

void SoExtSelection::setLassoColor | ( | const SbColor & | color | ) |

Sets the lasso/rectangle line color. Default value is (1.0, 1.0, 1.0).

## getLassoColor()

const SbColor & SoExtSelection::getLassoColor | ( | void |  | ) |

Returns the lasso color.

## setLassoWidth()

void SoExtSelection::setLassoWidth | ( | const float | width | ) |

Sets the lasso line width. Default value is 1.0.

## getLassoWidth()

float SoExtSelection::getLassoWidth | ( | void |  | ) |

Returns the lasso line width.

## setOverlayLassoPattern()

void SoExtSelection::setOverlayLassoPattern | ( | const unsigned short | pattern | ) |

Sets the lasso line pattern. Default value is 0xf0f0.

## getOverlayLassoPattern()

unsigned short SoExtSelection::getOverlayLassoPattern | ( | void |  | ) |

Returns the lasso line pattern.

## animateOverlayLasso()

void SoExtSelection::animateOverlayLasso | ( | const SbBool | animate = TRUE | ) |

Sets whether the lasso should be animated by scrolling the line pattern.

## isOverlayLassoAnimated()

SbBool SoExtSelection::isOverlayLassoAnimated | ( | void |  | ) |

Returns whether the lasso is set to animate or not.

## handleEvent()

void SoExtSelection::handleEvent | ( | SoHandleEventAction * | action | ) |

virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoSelection.

## GLRenderBelowPath()

void SoExtSelection::GLRenderBelowPath | ( | SoGLRenderAction * | action | ) |

virtual

SGI Open Inventor v2.1 obsoleted support for SoGLRenderAction::addMethod(). Instead, GLRender() might be called directly, and to optimize traversal, the SoSeparator node calls GLRenderBelowPath whenever the path code is BELOW_PATH or NO_PATH (path code is guaranteed not to change). To be compatible with SGI's Inventor (and thereby also TGS') we have chosen to follow their implementation in this respect.

SoSeparator::GLRenderBelowPath() does not traverse its children using SoChildList::traverse(), but calls GLRenderBelowPath() directly for all its children.

Reimplemented from SoSeparator.

## select() [1/2]

void SoExtSelection::select | ( | SoNode * | root,
|  | int | numcoords,
|  | SbVec2f * | lasso,
|  | const SbViewportRegion & | vp,
|  | SbBool | shiftpolicy )

Simulate lasso selection programmatically.

This function is currently just stubbed.

## select() [2/2]

void SoExtSelection::select | ( | SoNode * | root,
|  | int | numcoords,
|  | SbVec3f * | lasso,
|  | const SbViewportRegion & | vp,
|  | SbBool | shiftpolicy )

Simulate lasso selection programmatically.

This function is currently just stubbed.

## getLassoCoordsDC()

const SbVec2s * SoExtSelection::getLassoCoordsDC | ( | int & | numCoords | ) |

Returns lasso coordinates in device coordinates.

This function is currently just stubbed.

## getLassoCoordsWC()

const SbVec3f * SoExtSelection::getLassoCoordsWC | ( | int & | numCoords | ) |

Returns lasso coordinates in world coordinates.

This function is currently just stubbed.

## getSelectionPathList()

const SoPathList & SoExtSelection::getSelectionPathList | ( |  | ) | const

Returns a path list containing selected objects.

This function is currently just stubbed.

## setLassoFilterCallback()

void SoExtSelection::setLassoFilterCallback | ( | SoLassoSelectionFilterCB * | f,
|  | void * | userdata = NULL,
|  | const SbBool | callonlyifselectable = TRUE )

The lasso selection filter callback is called when a node is about to be selected, and enables the application programmer to return a new path to be used when selecting. The new returned path should not be ref'd. SoExtSelection will ref() and unref() it.

To cancel the selection, return NULL from the callback.

if callonlyifselectable is TRUE, the callback will only be invoked when the path to the new node pass through the SoExtSelection node.

This method is specific to Coin, and is not part of TGS OIV.

## setTriangleFilterCallback()

void SoExtSelection::setTriangleFilterCallback | ( | SoExtSelectionTriangleCB * | func,
|  | void * | userdata = NULL )

Sets the callback that will be called for every triangle inside the lasso/rectangle when selecting.

The callback should return `FALSE` if it wants to continue being invoked. When the callback returns `TRUE`, the object/shape is selected, and no more callbacks will be invoked for the object.

See also
  setLineSegmentFilterCallback, setPointFilterCallback

## setLineSegmentFilterCallback()

void SoExtSelection::setLineSegmentFilterCallback | ( | SoExtSelectionLineSegmentCB * | func,
|  | void * | userdata = NULL )

Sets the callback that will be called for every line segment inside the lasso/rectangle when selecting.

The callback should return `FALSE` if it wants to continue being invoked. When the callback returns `TRUE`, the object/shape is selected, and no more callbacks will be invoked for the object.

See also
  setTriangleFilterCallback, setPointFilterCallback

## setPointFilterCallback()

void SoExtSelection::setPointFilterCallback | ( | SoExtSelectionPointCB * | func,
|  | void * | userdata = NULL )

Sets the callback that will be called for every point inside the lasso/rectangle when selecting.

The callback should return `FALSE` if it wants to continue being invoked. When the user returns `TRUE`, the object/shape is selected, and no more callbacks will be invoked for the object.

See also
  setLineSegmentFilterCallback, setTriangleFilterCallback

## wasShiftDown()

SbBool SoExtSelection::wasShiftDown | ( | void |  | ) | const

Returns whether the `SHIFT` key was pressed during the latest user interaction. This is useful if you want to respect the shift policy while selecting primitives.

This method is specific to Coin, and is not part of TGS OIV.

## Member Data Documentation

## lassoType

SoSFEnum SoExtSelection::lassoType

Field for lasso type. Default value is SoExtSelection::NOLASSO.

Selections with type SoExtSelection::RECTANGLE or SoExtSelection::LASSO can be aborted by the end-user by hitting the `END` key on the keyboard.

## lassoPolicy

SoSFEnum SoExtSelection::lassoPolicy

Field for lasso policy. Default value is FULL_BBOX.

## lassoMode

SoSFEnum SoExtSelection::lassoMode

Field for lasso mode. Default value is ALL_SHAPES.

Set this field to VISIBLE_SHAPES to make only the primitives visible from the current viewpoint be selected.

The documentation for this class was generated from the following files:

- SoExtSelection.h
- SoExtSelection.cpp